import { IInstantiationService, ServicesAccessor } from "./instantiation";
import { ServiceCollection } from "./serviceCollection";
export declare class InstantiationService implements IInstantiationService {
    _serviceBrand: any;
    private _services;
    private _strict;
    constructor(services?: ServiceCollection, strict?: boolean);
    createChild(services: ServiceCollection): IInstantiationService;
    invokeFunction<R>(signature: (accessor: ServicesAccessor, ...more: any[]) => R, ...args: any[]): R;
    createInstance(param: any, ...rest: any[]): any;
    private _verifyDependency(desc, service, dependency);
    private _createInstance<T>(desc, args);
    private _getOrCreateServiceInstance<T>(id);
    private _createAndCacheServiceInstance<T>(id, desc);
}
