import { Descriptor } from "./descriptors";
import { ServiceIdentifier, IConstructorSignature0, IService } from "./instantiation";
export declare const Services = "di.services";
export interface IServiceContribution<T extends IService> {
    id: ServiceIdentifier<T>;
    descriptor: Descriptor<T>;
}
export declare function registerSingleton<T extends IService>(id: ServiceIdentifier<T>, ctor: IConstructorSignature0<T>): void;
export declare function getServices(): IServiceContribution<any>[];
